#include <gtk/gtk.h>
#include "config.h"

static void printme( GtkWidget *widget,
                   gpointer   data )
{
    gedit_print(GTK_TEXT_VIEW(data));
}

static gboolean delete_event( GtkWidget *widget,
                              GdkEvent  *event,
                              gpointer   data )
{
    return FALSE;
}

/* Another callback */
static void destroy( GtkWidget *widget,
                     gpointer   data )
{
    gtk_main_quit ();
}

int main( int   argc,
          char *argv[] )
{
    GtkWidget *window;
    GtkWidget *button;
    GtkWidget *text;
    GtkTextBuffer *buffer;
    GtkWidget *vbox;
    GtkTextIter iter;
    
    gtk_init (&argc, &argv);
    
    window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    
    g_signal_connect (G_OBJECT (window), "delete_event",
		      G_CALLBACK (delete_event), NULL);
    
    g_signal_connect (G_OBJECT (window), "destroy",
		      G_CALLBACK (destroy), NULL);
    
    gtk_container_set_border_width (GTK_CONTAINER (window), 10);
    
    button = gtk_button_new_with_label ("Click me to print the text below");
    
    text = gtk_text_view_new();
    buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(text));
    gtk_text_buffer_get_start_iter(GTK_TEXT_BUFFER(buffer), &iter);
    gtk_text_buffer_insert(buffer, &iter, "The text visible in this GtkTextView\n"
		    			  "will be printed if you click on the\n"
		    			  "button.", -1);
    vbox = gtk_vbox_new(6, FALSE);
    
    gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 2);	
    gtk_box_pack_start(GTK_BOX(vbox), text, FALSE, FALSE, 2);	
    
    g_signal_connect (G_OBJECT (button), "clicked",
		      G_CALLBACK (printme), text);
    
        
    gtk_container_add (GTK_CONTAINER (window), vbox);
    gtk_window_set_position(GTK_WINDOW (window), GTK_WIN_POS_CENTER);
    gtk_widget_show_all (window);
    
    gtk_main ();
    
    return 0;
}
